<script lang="ts" setup>
import { useCategoryStore } from "@/stores/category";
import { useProductStore } from "@/stores/product";
import { onMounted, ref } from "vue";
import type { VForm } from "vuetify/components";
const form = ref<VForm | null>(null);
const productStore = useProductStore();
const categoryStore = useCategoryStore();
async function save() {
  const { valid } = await form.value!.validate();
  if (valid) {
    await productStore.saveProduct();
  }
}
onMounted(async () => {
  await categoryStore.getCategory();
});
</script>
<template>
  <v-dialog v-model="productStore.dialog" persistent width="1024">
    <v-card>
      <v-card-title>
        <span class="text-h5">เพิ่มสินค้า</span>
      </v-card-title>
      <v-card-text>
        <v-form ref="form">
          <v-container>
            <v-row>
              <v-col cols="12">
                <v-text-field label="ชื่อสินค้า*" required v-model="productStore.editedProduct.name" :rules="[
                  (v) => !!v || 'ชื่อสินค้าห้ามว่าง',
                  (v) => v.length >= 3 || 'ชื่อสินค้าต้องมีตัวอักษรมากกว่าหรือเท่ากับ 3 ตัวขึ้นไป',
                ]"></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-text-field label="รายละเอียดสินค้า*" required v-model="productStore.editedProduct.description" :rules="[
                  (v) => !!v || 'รายละเอียดสินค้าห้ามว่าง',
                  (v) => v.length >= 3 || 'รายละเอียดสินค้าต้องมีตัวอักษรมากกว่าหรือเท่ากับ 3 ตัวขึ้นไป',
                ]"></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-text-field label="ราคา*" required v-model.number="productStore.editedProduct.price"
                  :rules="[(v) => !!v || 'ราคาสินค้าห้ามว่าง']"></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-text-field label="จำนวนสินค้าขั้นต่ำ*" required v-model="productStore.editedProduct.minquantity"
                  :rules="[
                    (v) => !!v || 'จำนวนสินค้าขั้นต่ำห้ามว่าง',
                    (v) => v.length >= 1 || 'จำนวนสินค้าขั้นต่ำต้องมากกว่าหรือเท่ากับ 1',
                  ]"></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-text-field label="จำนวนปัจจุบัน*" required v-model="productStore.editedProduct.qtybefore" :rules="[(v) => !!v || 'จำนวนปัจจุบันห้ามว่าง',
                (v) => v.length >= 1 || 'จำนวนปัจจุบันต้องมากกว่าหรือเท่ากับ 1',
                ]"></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-file-input v-model="productStore.editedProduct.files" accent="image/*"
                  label="เลือกรูปภาพ"></v-file-input>
              </v-col>
              <v-col cols="12">
                <v-select v-model="productStore.editedProduct.categoryId" :items="categoryStore.category"
                  item-title="name" item-value="id" label="หมวดหมู่" single-line></v-select>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue-darken-1" variant="text" @click="productStore.dialog = false">
          Close
        </v-btn>
        <v-btn color="blue-darken-1" variant="text" @click="save"> Save </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
